<cmps_foundamental_balance_table>
    
    <div class="block inset cbox">
        <div class="data-table">
            <table>
                <thead>
                    <tr>
                        <th></th>
                        <th if="{opts.clickCB!=undefined}" class="tablet-only"><i class="far fa-check-square"></i></th>
                        <th>{i18n.localise("貨幣")}</th>
                        <th class="numeric-cell">{i18n.localise("餘額")}</th>
                        <th class="numeric-cell tablet-only">{i18n.localise("市值")}(USD)</th>
                        <!-- <th></th> -->
                    </tr>
                </thead>
                <tbody>
                    <tr each="{currency_balance in currency_balances}" onclick="{opts.clickCB}">
                        <td><img src="assets/currency-icons/32/color/{currency_balance.currency.toLowerCase()}.png" if="{currency_balance.showIcon}" /></td>
                        <td if="{opts.clickCB!=undefined}" class="tablet-only"><i class="far fa-square"></i></td>
                        <td>{currency_balance.currency}</td>
                        <td class="numeric-cell">{numeral(currency_balance.balance).format("0,0.000")}</td>
                        <td class="numeric-cell tablet-only">{numeral(currency_balance.marketCapitalization).format("0,0.000")}</td>
                        <!-- <td><div if="{currency_balance.category_type=='B'}" class="button button-small button-outline color-yellow" onclick="{deposit}"><i1-8n>儲值</i1-8n></div></td> -->
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <div class="block-title" style="text-align: right;">{i18n.localise("資產淨值約")} {numeral(marketCapitalization).format("0,0.00")} USD</div>
    <div id="pieChar" class="block" if="{opts.showPieChar}">
        <svg width="300" height="300"></svg>
    </div>
    <style>
        #pieChar {
            text-align: right;
        }
        .arc text {
            font: 10px sans-serif;
            text-anchor: middle;
        }
        .arc path {
            stroke: #fff;
        }
        tr {
            font-size: 1.5em;
        }
    </style>
    <script>
        var cmp = this;
		cmp.name = "cmps_foundamental_balance_table";
        cmp.currency_balances = [];
        cmp.exchange_rates = {};
        cmp.marketCapitalization = 0;
        cmp.on('mount',function(){
			jApp.cmpReg[cmp.name] = this;
            $.get(API_ENDPOINT+"/exchange_rates", function(data){
//                console.log(data);
                for ( var i = 0 ; i < data.length ; ++i )
                    cmp.exchange_rates[data[i].currency] = data[i];
                cmp.loadData();
            });
            
        });
        cmp.loadData = function(){
            $.get(API_ENDPOINT+"/member/balance/"+jApp.storage.getItem("UserId"), function(data){
//                console.log(data);
                var rate = 0.000000000000000001;
                // cmp.currency_balances.push({sale: cmp.exchange_rates['USDT'].sale, category_type: cmp.exchange_rates['USDT'].category_type, showIcon: true, currency: 'USDT', balance: data.usdt_balance*rate, marketCapitalization: data.usdt_balance * 1});
//                cmp.currency_balances.push({sale: cmp.exchange_rates['CNYT'].sale, category_type: cmp.exchange_rates['CNYT'].category_type, showIcon: true, currency: 'CNYT', balance: data.cnyt_balance*1, marketCapitalization: data.cnyt_balance*1 / cmp.exchange_rates['CNYT'].buy*1});
//                cmp.currency_balances.push({sale: cmp.exchange_rates['TWDT'].sale, category_type: cmp.exchange_rates['TWDT'].category_type, showIcon: true, currency: 'TWDT', balance: data.twdt_balance*1, marketCapitalization: data.twdt_balance*1 / cmp.exchange_rates['TWDT'].buy*1});
                cmp.currency_balances.push({sale: cmp.exchange_rates['SUP'].sale, category_type: cmp.exchange_rates['SUP'].category_type , showIcon: true, currency: 'SUP' , balance: data.sup_balance*rate , marketCapitalization: data.sup_balance*rate  / cmp.exchange_rates['SUP'].buy*1});
                // cmp.currency_balances.push({sale: cmp.exchange_rates['ETH'].sale, category_type: cmp.exchange_rates['ETH'].category_type , showIcon: true, currency: 'ETH' , balance: data.eth_balance*1+data.cache_balance*0.000000000000000001 , marketCapitalization: (data.eth_balance*1+data.cache_balance*0.000000000000000001)  / cmp.exchange_rates['ETH'].buy*1});
                // cmp.currency_balances.push({sale: cmp.exchange_rates['BTC'].sale, category_type: cmp.exchange_rates['BTC'].category_type , showIcon: true, currency: 'BTC' , balance: data.btc_balance*rate , marketCapitalization: data.btc_balance*rate  / cmp.exchange_rates['BTC'].buy*1});
                // cmp.currency_balances.push({sale: cmp.exchange_rates['LTC'].sale, category_type: cmp.exchange_rates['LTC'].category_type , showIcon: true, currency: 'LTC' , balance: data.ltc_balance*rate , marketCapitalization: data.ltc_balance*rate  / cmp.exchange_rates['LTC'].buy*1});
                cmp.currency_balances.push({sale: cmp.exchange_rates['PSW'].sale, category_type: cmp.exchange_rates['PSW'].category_type , showIcon: true, currency: 'PSW' , balance: data.psw_balance*rate , marketCapitalization: data.psw_balance*rate  / cmp.exchange_rates['PSW'].buy*1});
                cmp.currency_balances.push({sale: cmp.exchange_rates['SCOIN'].sale, category_type: cmp.exchange_rates['SCOIN'].category_type , showIcon: true, currency: 'SCOIN' , balance: data.scoin_balance*rate , marketCapitalization: data.scoin_balance*rate  / cmp.exchange_rates['SCOIN'].buy*1});
                
                for ( var i = 0 ; i < cmp.currency_balances.length ; ++i ){
//                    console.log(cmp.currency_balances[i].currency, cmp.currency_balances[i].marketCapitalization);
                    cmp.marketCapitalization += cmp.currency_balances[i].marketCapitalization;
                }
                
                cmp.update();
                
                if ( opts.showPieChar ){
                    $("#pieChar").width($('#mainTopNavi').width()-32);
                    cmp.plot();
                }
                
                
                
            });
            
        }
        cmp.deposit = function(e){
            jApp.loadCmp("cmps_trade_deposit", e.item.currency_balance);
        }
        cmp.plot = function(){
            var svg = d3.select("svg"),
                width = +svg.attr("width"),
                height = +svg.attr("height"),
                radius = Math.min(width, height) / 2,
                g = svg.append("g").attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");

            var color = d3.scaleOrdinal(["#98abc5", "#8a89a6", "#7b6888", "#6b486b", "#a05d56", "#d0743c", "#ff8c00"]);

            var pie = d3.pie()
                .sort(null)
                .value(function(d) { return d.marketCapitalization; });

            var path = d3.arc()
                .outerRadius(radius - 10)
                .innerRadius(0);

            var label = d3.arc()
                .outerRadius(radius - 40)
                .innerRadius(radius - 40);
            
            var arc = g.selectAll(".arc")
                    .data(pie(cmp.currency_balances))
                    .enter().append("g")
                    .attr("class", "arc");

                arc.append("path")
                    .attr("d", path)
                    .attr("fill", function(d) { return color(d.data.currency); });

                arc.append("text")
                    .attr("transform", function(d) { return "translate(" + label.centroid(d) + ")"; })
                    .attr("dy", "0.35em")
                    .text(function(d) { return d.data.currency; });
        }
        
    </script>
</cmps_foundamental_balance_table>